<?php

/*
 * admin.class.php
 *
 * @copyright     Copyright 2009-2011 Hamid Reza Samak
 * @link          http://www.limny.org
 * @package       limny
 * @author        Hamid Reza Samak <hamid@limny.org>
 * @license       GNU/GPL License (http://www.gnu.org/licenses/gpl.html)
 */

class Admin
{
	function is_permitted($page)
	{
		$class['user'] = new User;
		$class['config'] = new Config;
		
		$admin = unserialize($class['config']->admin);
		$privileges = $this->role_get_info('admin', $class['user']->user_get_info('role'));
		
		if($privileges != 'all')
		{
			foreach($admin as $key => $value)
			{
				if(in_array($page, explode(',', $value[1])))
				{
					if(in_array($key, explode(',', $privileges)))
					{
						return true;
					}
				}
			}
		}else{
			foreach($admin as $key => $value)
			{
				if(in_array($page, explode(',', $value[1])))
				{
					return true;
				}
			}
		}
		
		return false;
	}
	
	function is_admin($user = '')
	{
		global $db;
		
		$user = (!empty($user)) ? add_slashes($user) : $_SESSION['_user'];
		$query = $db->select('admin', 'users', "WHERE user='$user' AND admin='1'");
		return ($user = $db->fetch_array($query)) ? true : false;		
	}
	
	function check_session()
	{
		if(!$this->is_authorized())
		{
			header('Location: login.php');
		}
	}
	
	function is_authorized()
	{
		$class['user'] = new User;
		
		if($class['user']->is_authorized())
		{
			return ($this->is_admin()) ? true : false;
		}
		
		return false;
	}
	
	function role_get_info($field = '*', $id)
	{
		global $db;
		
		$query = $db->select($field, 'roles', 'WHERE id=\'' . add_slashes($id) . '\'');
		if($role = $db->fetch_array($query))
		{
			return ($field == '*' || strpos($field, ',') !== false) ? $role : $role[$field];
		}
	}
	
	function theme_is_compatible($theme)
	{
		$class['file'] = new File;
		$class['config'] = new Config;
		
		$version = $class['file']->get_version('../themes/' . $theme . '/' . $theme . '.info');
		$star = strpos(strtolower($version), '*');
		
		if(empty($star))
		{
			return ($version === $class['config']->version) ? true : false;
		}else{
			$version = substr($version, 0, $star);
			$limny = substr($class['config']->version, 0, $star);
			return ($version === $limny) ? true : false;
		}
	}
	
	function reset_users_theme($theme)
	{
		global $db;
		
		$ids = array();
		
		$query = $db->select('id', 'users', 'WHERE theme=\'' . add_slashes($theme) . '\'');
		while($user = $db->fetch_array($query))
		{
			array_push($ids, $user['id']);
		}
		
		foreach($ids as $id)
		{
			$db->update('users', 'theme=\'\' WHERE id=\'' . $id . '\'');
		}
	}
	
	function theme_get_info($theme)
	{
		$class['file'] = new File;
		
		$file = $class['file']->get_contents('../themes/' . $theme . '/' . $theme . '.info');
		
		$data = explode("\r\n\r\n", $file);
		$data = $data[1];
		$line = explode("\n", $data);
		$info = array();
		for($i=0; $i<count($line); $i++)
		{
			$item = explode('=', $line[$i]);
			$info[trim($item[0])] = trim($item[1]);
		}
		return $info;
	}
	
	function installed_themes()
	{
		global $db;
		
		$themes = array();
		
		$query = $db->select('name', 'themes');
		while($theme = $db->fetch_array($query))
		{
			array_push($themes, $theme['name']);
		}
		
		return $themes;
	}
	
	function themes_list()
	{
		$themes = array();
		
		$dir = opendir('../themes');
		while($theme = readdir($dir))
		{
			if($theme != '.' && $theme != '..' && is_dir('../themes/' . $theme))
			{
				array_push($themes, $theme);
			}
		}
		closedir($dir);
		
		return $themes;
	}
	
	function update_apps_name()
	{
		global $db;
		
		$names = array();
		$apps = $this->installed_apps();
		foreach($apps as $app)
		{
			$info = $this->app_get_info($app);
			array_push($names, array($app, $info['name']));
		}
		
		$names = (count($names) > 0) ? serialize($names) : false;
		
		$db->update('config', "value='$names' WHERE name='apps_name'");
	}
	
	function get_app($app, $field = '')
	{
		global $db;
		
		$query = $db->select($field, 'apps', 'WHERE name=\'' . add_slashes($app) . '\'');
		if($app = $db->fetch_array($query))
		{
			return ($field == '*' || strpos($field, ',') === true) ? $app : $app[$field];
		}
	}
	
	function app_get_info($app)
	{
		$class['file'] = new File;
		
		$file = $class['file']->get_contents('../apps/' . $app . '/' . $app . '.info');
		
		$line = explode("\n", $file);
		$info = array();
		for($i=2; $i<count($line); $i++)
		{
			$item = explode('=', $line[$i]);
			$info[trim($item[0])] = trim($item[1]);
		}
		
		return $info;
	}
	
	function installed_apps()
	{
		global $db;
		
		$apps = array();
		
		$query = $db->select('name', 'apps', 'ORDER BY id');
		while($app = $db->fetch_array($query))
		{
			array_push($apps, $app['name']);
		}
		
		return $apps;
	}
}

?>
