<?php

/*
 * appearance.tpl
 *
 * @copyright     Copyright 2009-2011 Hamid Reza Samak
 * @link          http://www.limny.org
 * @package       limny
 * @author        Hamid Reza Samak <hamid@limny.org>
 * @license       GNU/GPL License (http://www.gnu.org/licenses/gpl.html)
 */

require('../incs/file.class.php');

$themes = '<img class="install" src="../misc/install-64.png" alt="install" /><img class="uninstall" src="../misc/uninstall-64.png" alt="uninstall" /><img class="setasdefault" src="../misc/default-64.png" alt="default" /><div class="table themes">';
foreach($class['admin']->themes_list() as $key => $theme)
{
	$themes .= ($key % 2 == 0) ? '<div class="row">' : false;
	$info = $class['admin']->theme_get_info($theme);
	
	$default = ($class['config']->theme == $theme) ? ' default' : false;
	
	$screenshot = (file_exists('../themes/' . $theme . '/screenshot.png')) ? '<img src="../themes/' . $theme . '/screenshot.png" alt="' . $theme . '" class="screenshot" />' : '<img src="../misc/appearance-128.png" alt="' . $theme . '" class="screenshot" />';
	
	if(in_array($theme, $class['admin']->installed_themes()))
	{
		$images_query = $db->select('id', 'images', 'WHERE theme=\'' . add_slashes($theme) . '\'');
		$styles_query = $db->select('id', 'images', 'WHERE theme=\'' . add_slashes($theme) . '\'');
		$styles = ($db->num_rows($images_query) > 0 || $db->num_rows($styles_query) > 0) ? '<li class="styles"><a href="index.php?p=styles/' . $theme . '">' . STYLES . '</a></li>' : null;
		
		$manage = '<ul>' . $styles . '<li class="edit"><a href="index.php?p=edit/' . $theme . '">' . EDIT . '</a></li><li class="uninstall"><a href="#' . $theme . '">' . UNINSTALL . '</a></li></ul>';
		
		$manage = ($class['config']->theme != $theme) ? '<ul><li class="setasdefault"><a href="#' . $theme . '">' . SET_AS_DEFAULT . '</a></li></ul>' . $manage : $manage;
		$screenshot = '<a href="#preview" class="screenshot">' . $screenshot . '</a>';
	}else{
		$manage = '<ul><li class="install"><a href="#' . $theme . '">' . INSTALL . '</a></li><li class="edit"><a href="index.php?p=edit/' . $theme . '">' . EDIT . '</a></li></ul>';
	}
	
	$themes .= '<div id="' . $theme . '" class="cell theme' . $default . '"><span class="name">' . $info['name'] . '</span><br /><div class="screenshot">' . $screenshot . '</div><br /><span class="desc">' . $info['description'] . '</span><br /><br /><div class="manage">' . $manage . '</div></div>';
	$themes .= ($key % 2) ? '</div>' : false;
	
	unset($info);
	unset($manage);
	unset($default);
}
$themes .= (($key % 2) ? null : '</div>') . '</div><div id="msgbox"></div><div id="msgcnt"><div class="alert"></div><div class="okay"><a href="#" class="okay">[' . OKAY. ']</a></div></div><div id="preview-border"></div><div id="preview"><iframe src="#"></iframe></div>';


$page['title'] = APPEARANCE;
$page['head'] = '<link href="table.css" type="text/css" rel="stylesheet" />
<link href="' . (($class['language']->direction == 'rtl') ? 'rtl/appearance-rtl.css' : 'appearance.css') . '" type="text/css" rel="stylesheet" />
<link href="message.css" type="text/css" rel="stylesheet" />
<script type="text/javascript" src="appearance.js"></script>';
$page['content'] = $themes;

unset($themes);

?>
