<?php

/*
 * apps.tpl
 *
 * @copyright     Copyright 2009-2011 Hamid Reza Samak
 * @link          http://www.limny.org
 * @package       limny
 * @author        Hamid Reza Samak <hamid@limny.org>
 * @license       GNU/GPL License (http://www.gnu.org/licenses/gpl.html)
 */

require('../incs/file.class.php');
require('../incs/application.class.php');

$class['file'] = new File;
$class['application'] = new Application;

function apps_list()
{
	$apps = array();
	
	$dir = opendir('../apps');
	while($app = readdir($dir))
	{
		if($app != '.' && $app != '..' && is_dir('../apps/' . $app))
		{
			array_push($apps, $app);
		}
	}
	closedir($dir);
	
	return $apps;
}

function app_is_installed($app, $ver = '')
{
	global $db;
	
	$query = $db->select('id', 'apps', 'WHERE name=\'' . add_slashes($app) . '\'');
	
	if($apps = $db->fetch_array($query))
	{
		if(!empty($ver))
		{
			$class['admin'] = new Admin;
			$info = $class['admin']->app_get_info($app);
			
			return ($ver == $info['version']) ? true : false;
		}
	}
	
	return false;
}

function add_req_by($app, $req_by)
{
	global $db;
	
	$app = add_slashes($app);
	$query = $db->select('reqby', 'apps', 'WHERE name=\'' . $app . '\'');
	if($apps = $db->fetch_array($query))
	{
		if(empty($apps['reqby']))
		{
			$db->update('apps', 'reqby=\'' . add_slashes($req_by) . '\' WHERE name=\'' . $app . '\'');
		}else{
			$new_req_by = '';
			foreach(explode(',', $apps['reqby']) as $value)
			{
				if($value != $req_by)
				{
					$new_req_by .= $value . ',';
				}
			}
			$new_req_by = substr($new_req_by, 0, strlen($new_req_by)-1);
			
			$db->update('apps', 'reqby=\'' . add_slashes($new_req_by) . ',' . add_slashes($req_by) . '\' WHERE name=\'' . $app . '\'');
		}
	}
}

function remove_req_by($app, $req_by)
{
	global $db;
	
	$app = add_slashes($app);
	$query = $db->select('reqby', 'apps', 'WHERE name=\'' . $app . '\'');
	if($apps = $db->fetch_array($query))
	{
		$new_req_by = '';
		foreach(explode(',', $apps['reqby']) as $value)
		{
			if($value != $req_by)
			{
				$new_req_by .= $value . ',';
			}
		}
		$new_req_by = substr($new_req_by, 0, strlen($new_req_by)-1);
		
		$db->update('apps', 'reqby=\'' . add_slashes($new_req_by) . '\' WHERE name=\'' . $app . '\'');
	}
}

if(isset($_GET['p'][1]))
{
	require('../incs/form.class.php');
	$class['form'] = new Form;
	
	$app = @$_GET['p'][2];
	
	if($class['form']->validate_referer($class['config']->site . '/admin/index.php?p=apps', strlen($class['config']->site) + 23))
	{
		switch($_GET['p'][1])
		{
			case('save');
				$except = array();
				foreach($class['admin']->installed_apps() as $app)
				{
					if(isset($_POST[$app]))
					{
						if(!$class['application']->is_enabled($app))
						{
							$info = $class['admin']->app_get_info($app);
							if(!empty($info['dependedon']))
							{
								foreach(explode(',', $info['dependedon']) as $value)
								{
									$value = substr($value, 0, strpos($value, '('));
									add_req_by($value, $app . '(' . $info['version'] . ')');
								}
							}
							
							$db->update('apps', 'enabled=1 WHERE name=\'' . add_slashes($app) . '\'');
							$db->update('head', 'enabled=1 WHERE app=\'' . add_slashes($app) . '\'');
						}
					}else{
						$req_by = $class['admin']->get_app($app, 'reqby');
						if(empty($req_by) && $class['application']->is_enabled($app) && !in_array($app, $except))
						{
							$info = $class['admin']->app_get_info($app);
							if(!empty($info['dependedon']))
							{
								foreach(explode(',', $info['dependedon']) as $value)
								{
									$value = substr($value, 0, strpos($value, '('));
									remove_req_by($value, $app . '(' . $info['version'] . ')');
									
									array_push($except, $value);
								}
							}
							
							$db->update('apps', 'enabled=0 WHERE name=\'' . add_slashes($app) . '\'');
							$db->update('head', 'enabled=0 WHERE app=\'' . add_slashes($app) . '\'');
						}
					}
				}
			break;
			
			case('install');
				if(in_array($app, apps_list()) && !in_array($app, $class['admin']->installed_apps()))
				{
					if($class['application']->is_compatible($app))
					{
						if(file_exists('../apps/' . $app . '/install.php'))
						{
							include('../apps/' . $app . '/install.php');
							if(function_exists('install'))
							{
								$install = install();
								$class['admin']->update_apps_name();
								
								$info = $class['admin']->app_get_info($app);
							}
						}
					}
				}
			break;
			
			case('uninstall');
				if(isset($_POST['uninstall']) && isset($_POST['yes']))
				{
					if(strtoupper($_POST['yes']) === 'YES')
					{
						if(in_array($app, $class['admin']->installed_apps()))
						{
							$info = $class['admin']->app_get_info($app);
							
							if(!$class['application']->is_enabled($app))
							{
								if(file_exists('../apps/' . $app . '/install.php'))
								{
									include('../apps/' . $app . '/install.php');
									if(function_exists('uninstall'))
									{
										$uninstall = uninstall();
										$class['admin']->update_apps_name();
										if($class['config']->content_default == 'app' && $class['config']->content_app == $app)
										{
											$db->update('config', 'value=\'\' WHERE name=\'content_app\'');
											$db->update('config', 'value=\'code\' WHERE name=\'content_default\'');
										}
									}
								}
							}
						}
					}
				}
			break;
		}
	}
	unset($class['form']);
}

$installed = '';
$uninstalled = '';
$num['installed'] = 1;
$num['uninstalled'] = 1;

foreach(apps_list() as $app)
{
	$info = $class['admin']->app_get_info($app);
	
	if(in_array($app, $class['admin']->installed_apps()))
	{
		$checked = ($class['application']->is_enabled($app)) ? ' checked="checked"' : false;
		
		$disabled = '';
		if(!empty($info['dependedon']))
		{
			$for_checkbox = true;
			$dependedon = '<br /><br /><span class="light">(' . DEPENDED_ON . ': ';
			foreach(explode(',', $info['dependedon']) as $value)
			{
				$depend_name = substr($value, 0, strpos($value, '('));
				$depend_vers = substr($value, strpos($value, '(') + 1, strpos($value, ')') - strpos($value, '(') - 1);
				
				if(app_is_installed($depend_name, $depend_vers))
				{
					$depend_info = $class['admin']->app_get_info($depend_name);
					$dependedon .= $depend_info['name'] . ' ' . $depend_vers . ' &amp; ';
					unset($depend_info);
				}else{
					$dependedon .= $depend_name. ' ' . $depend_vers . ' &amp; ';
				}
				
				if(!app_is_installed($depend_name, $depend_vers) || !$class['application']->is_enabled($depend_name))
				{
					$for_checkbox = false;
				}
			}
			$dependedon = substr($dependedon, 0, strlen($dependedon) - 7);
			$dependedon .= ')</span>';
			
			if(!$for_checkbox)
			{
				$disabled = ' disabled="disabled"';
			}
		}else{
			$dependedon = '';
		}
		
		$req_by = $class['admin']->get_app($app, 'reqby');
		if(!empty($req_by))
		{
			$requiredby = '<br /><br /><span class="light">(' . REQUIRED_BY . ': ';
			foreach(explode(',', $req_by) as $value)
			{
				$required_info = $class['admin']->app_get_info(substr($value, 0, strpos($value, '(')));
				$requiredby .= $required_info['name'] . ' ' . $required_info['version'] . ' & ';
			}
			$requiredby = substr($requiredby, 0, strlen($requiredby) - 3);
			$requiredby .= ')</span>';
			
			$disabled = ' disabled="disabled"';
		}else{
			$requiredby = '';
		}
		
		$odd_or_even = ($num['installed'] % 2) ? 'odd' : 'even';
		
		$installed .= '<div id="' . $app . '" class="row app ' . $odd_or_even . '">
		<div class="cell pad check"><input name="' . $app . '" type="checkbox" value="1"' . $checked . $disabled . ' /></div>
		<div class="cell pad name">' . $info['name'] . ' <span class="light">' . $info['version'] . '</span><div class="manage"><a href="#' . $app . '" class="uninstall" style="color: #EE0000;">[' . UNINSTALL . ']</a></div>' . $dependedon . $requiredby . '</div>
		<div class="cell pad desc">' . $info['description'] . '</div>
	</div>';
		
		$num['installed']++;
	}else{
		$odd_or_even = ($num['uninstalled'] % 2) ? 'odd' : 'even';
		
		$uninstalled .= '<div class="row app ' . $odd_or_even . '">
		<div class="cell pad check"></div>
		<div class="cell pad name">' . $info['name'] . ' <span class="light">' . $info['version'] . '</span> ' . ((!$class['application']->is_compatible($app)) ? '<span class="red">(' . NOT_COMPATIBLE . ')</span>' : null) . '<div class="manage"><a href="index.php?p=apps/install/' . $app . '" style="color: #009933;">[' . INSTALL . ']</a></div></div>
		<div class="cell pad desc">' . $info['description'] . '</div>
	</div>';
		
		$num['uninstalled']++;
	}
}

unset($app);
unset($num);
unset($info);

if(empty($installed))
{
	$installed = '<div class="row odd">
		<div class="cell pad"></div>
		<div class="cell pad light">' . INFO_7 . '</div>
		<div class="cell pad"></div>
	</div>';
}

if(empty($uninstalled))
{
	$uninstalled = '<div class="row odd">
		<div class="cell pad"></div>
		<div class="cell pad light">' . INFO_8 . '</div>
		<div class="cell pad"></div>
	</div>';
}

$page['title'] = APPLICATIONS;
$page['head'] = '<link href="table.css" type="text/css" rel="stylesheet" />
<link href="' . (($class['language']->direction == 'rtl') ? 'rtl/apps-rtl.css' : 'apps.css') . '" type="text/css" rel="stylesheet" />
<link href="' . (($class['language']->direction == 'rtl') ? 'rtl/form-rtl.css' : 'form.css') . '" type="text/css" rel="stylesheet" />
<link href="message.css" type="text/css" rel="stylesheet" />
<script type="text/javascript" src="apps.js"></script>';

$page['content'] = '<span class="title">' . APPLICATIONS . '</span>
<form name="applications" action="index.php?p=apps/save" method="post">
<div class="table applications">
	<div class="row head">
		<div class="cell check"></div>
		<div class="cell name">' . NAME . '</div>
		<div class="cell desc">' . DESCRIPTION . '</div>
	</div>
	
	<div class="row">
		<div class="cell dash">-</div>
		<div class="cell subject">' . INSTALLED . '</div>
		<div class="cell"></div>
	</div>
	' . $installed . '
	<div class="row">
		<div class="cell dash">-</div>
		<div class="cell subject">' . READY_TO_INSTALL . '</div>
		<div class="cell"></div>
	</div>
	' . $uninstalled . '
	<div class="row">
		<div class="cell"></div>
		<div class="cell"></div>
		<div class="cell button"><input name="save" type="submit" value="' . UPDATE . '" /></div>
	</div>
</div>
</form>

<form id="uninstall" name="uninstall" action="index.php?p=apps/uninstall" method="post">
<div id="msgbox"></div>
<div id="msgcnt">
	<div style="font-weight: bold;">' . INFO_10 . '</div>
	<br />
	<div style="text-align: center">' . PLEASE_TYPE_YES_IN_THE_FIELD . ': <input name="yes" type="text" value="" size="5" class="yes" /></div>
	<br />
	<div style="text-align: center;"><input name="uninstall" type="submit" value="' . UNINSTALL . '" /> &nbsp; <a href="#" class="cancel">[' . NOPE . ']</a></div>
</div>
</form>';

unset($installed);
unset($uninstalled);

?>
