<?php

/*
 * config.tpl
 *
 * @copyright     Copyright 2009-2011 Hamid Reza Samak
 * @link          http://www.limny.org
 * @package       limny
 * @author        Hamid Reza Samak <hamid@limny.org>
 * @license       GNU/GPL License (http://www.gnu.org/licenses/gpl.html)
 */

if(isset($_POST['update']))
{
	require('../incs/form.class.php');
	$class['form'] = new Form;
	
	if($class['form']->validate_referer())
	{
		if(isset($_POST['title']))
		{
			$form['title'] = str_rep('&,<,>,"', '&amp;,&lt;,&gt;,&quot;', $_POST['title']);
		}
		
		if(isset($_POST['header']))
		{
			$form['header'] = str_rep('&,<,>,"', '&amp;,&lt;,&gt;,&quot;', $_POST['header']);
		}
		
		if(isset($_POST['site']))
		{
			$db->update('config', '`value`=\'' . str_rep('&,<,>,"', '&amp;,&lt;,&gt;,&quot;', $_POST['site']) . '\' WHERE name=\'site\'');
		}
		
		$content = array('app', 'query', 'code');
		if(in_array($_POST['content'], $content))
		{
			if($_POST['content'] == 'app')
			{
				if(isset($_POST['app']))
				{
					$form['content_default'] = 'app';
				}else{
					$form['content_default'] = $class['config']->content_default;
				}
			}else{
				$form['content_default'] = $_POST['content'];
			}
		}
		unset($content);
		
		if($form['content_default'] == 'app')
		{
			if(isset($_POST['app']))
			{
				$apps_name = $class['config']->apps_name;
				if(!empty($apps_name))
				{
					foreach(unserialize($apps_name) as $value)
					{
						if($_POST['app'] == $value[0])
						{
							$form['content_app'] = $_POST['app'];
							break;
						}
					}
				}
			}
		}
		else if($form['content_default'] == 'query')
		{
			if(isset($_POST['query']))
			{
				$form['content_query'] = str_rep('&,<,>,"', '&amp;,&lt;,&gt;,&quot;', $_POST['query']);
			}
		}
		else if($form['content_default'] == 'code')
		{
			if(isset($_POST['code']))
			{
				$form['content_code'] = $_POST['code'];
			}
		}
		
		if(isset($_POST['uri_mode']))
		{
			if($_POST['uri_mode'] == 'GET' || $_POST['uri_mode'] == 'REQUEST_URI')
			{
				$form['uri_mode'] = $_POST['uri_mode'];
			}
		}
		
		if(isset($_POST['rewrite']))
		{
			if($_POST['rewrite'] == '0' || $_POST['rewrite'] == '1')
			{
				$form['rewrite'] = $_POST['rewrite'];
			}
		}
		
		if(isset($_POST['strip_tags']))
		{
			$form['strip_tags'] = str_rep('&,"', '&amp;,&quot;', $_POST['strip_tags']);
		}
		
		if(isset($_POST['permalink']))
		{
			if($_POST['permalink'] == 'INCLUDE' || $_POST['permalink'] == 'REDIRECT')
			{
				$form['permalink'] = $_POST['permalink'];
			}
		}
		
		if(isset($_POST['registration']))
		{
			if($_POST['registration'] == '0' || $_POST['registration'] == '1')
			{
				$form['registration'] = $_POST['registration'];
			}
		}
		
		foreach($form as $key => $value)
		{
			$db->update('config', '`value`=\'' . add_slashes($value) . '\' WHERE name=\'' . $key . '\'');
		}
	}
	unset($class['form']);
}

$title = $class['config']->title;
$header = $class['config']->header;
$site = $class['config']->site;

$checked = array(
	'app' => '',
	'query' => '',
	'code' => '',
	'GET' => '',
	'REQUEST_URI' => '',
	'enable' => '',
	'disable' => '',
	'INCLUDE' => '',
	'REDIRECT' => '',
	'on' => '',
	'off' => ''
);

$content_default = $class['config']->content_default;
if($content_default == 'app')
{
	$checked['app'] = ' checked="checked"';
	
	$apps = '';
	foreach(unserialize($class['config']->apps_name) as $app)
	{
		$selected = ($app[0] == $class['config']->content_app) ? ' selected="selected"' : null;
		$apps .= '<option value="' . $app[0] . '"' . $selected . '>' . $app[1] . '</option>';
	}
	unset($app);
	unset($selected);
	
	$content = array(
		'name' => APPLICATION . ':<br /><span class="desc">' . INFO_18 . '</span>',
		'field' => '<select name="app">' . $apps . '</select>'
	);
	unset($apps);
}
else if($content_default == 'query')
{
	$checked['query'] = ' checked="checked"';
	
	$content = array(
		'name' => QUERY . ':<br /><span class="desc">' . INFO_19 . '</span>',
		'field' => '<input name="query" type="text" value="' . ($class['config']->content_query) . '" />'
	);
}
else if($content_default = 'code')
{
	$checked['code'] = ' checked="checked"';
	
	$content = array(
		'name' => CODE . ':<br /><span class="desc">' . INFO_20 . '</span>',
		'field' => '<textarea name="code" rows="10" cols="50">' . str_rep('&,<,>,"', '&amp;,&lt;,&gt;,&quot;', $class['config']->content_code) . '</textarea>'
	);
}
unset($content_default);

$uri_mode = $class['config']->uri_mode;
if($uri_mode == 'GET')
{
	$checked['GET'] = ' checked="checked"';
}
else if($uri_mode == 'REQUEST_URI')
{
	$checked['REQUEST_URI'] = ' checked="checked"';
}
unset($uri_mode);

$rewrite = $class['config']->rewrite;
if($rewrite == '1')
{
	$checked['enable'] = ' checked="checked"';
}
else if($rewrite == '0')
{
	$checked['disable'] = ' checked="checked"';
}
unset($rewrite);

$strip_tags = str_rep('<,>', '&lt;,&gt;', $class['config']->strip_tags);

$permalink = $class['config']->permalink;
if($permalink == 'INCLUDE')
{
	$checked['INCLUDE'] = ' checked="checked"';
}
else if($permalink == 'REDIRECT')
{
	$checked['REDIRECT'] = ' checked="checked"';
}
unset($permalink);

$registration = $class['config']->registration;
if($registration == '1')
{
	$checked['on'] = ' checked="checked"';
}
else if($registration == '0')
{
	$checked['off'] = ' checked="checked"';
}
unset($registration);

$configuration = '<form name="configuration" action="index.php?p=config" method="post">
<span class="title">' . GENERAL . '</span>
<div class="configuration table">
	<div class="row">
		<div class="cell name">' . TITLE . ':</div>
		<div class="cell field"><input name="title" type="text" value="' . $title . '" /></div>
	</div>
	<div class="row">
		<div class="cell name">' . HEADER . ':</div>
		<div class="cell field"><input name="header" type="text" value="' . $header . '" /></div>
	</div>
	<div class="row">
		<div class="cell name">' . SITE . ':<br /><span class="desc">' . FOR_EXAMPLE . ' http://domain-name/path</span></div>
		<div class="cell field"><input name="site" type="text" value="' . $site . '" /></div>
	</div>
</div>
<br />
<br />
<br />
<span class="title">' . CONTENT . '</span>
<div class="configuration table">
	<div class="row">
		<div class="cell name">' . CONTENT . ':<br /><span class="desc">' . INFO_17 . '</span></div>
		<div class="cell field contenttype"><label id="app"><input name="content" type="radio" value="app"' . $checked['app'] . ' /> ' . APPLICATION . '</label> &nbsp; <label id="query"><input name="content" type="radio" value="query"' . $checked['query'] . ' /> ' . QUERY . '</label> &nbsp; <label id="code"><input name="content" type="radio" value="code"' . $checked['code'] . ' /> ' . CODE . '</label></div>
	</div>
	<div class="row">
		<div class="cell name contentname">' . $content['name'] . '</div>
		<div class="cell field contentfield">' . $content['field'] . '</div>
	</div>
</div>
<br />
<br />
<br />
<span class="title">' . SETTINGS . '</span>
<div class="configuration table">
	<div class="row">
		<div class="cell name">' . URI_MODE . ':<br /><span class="desc">' . INFO_14 . '</span></div>
		<div class="cell field"><label><input name="uri_mode" type="radio" value="GET"' . $checked['GET'] . ' /> ' . GET . '</label><span class="desc">' . ($class['config']->site . '/index.php?q=hello') . '</span><br /><br /><label><input name="uri_mode" type="radio" value="REQUEST_URI"' . $checked['REQUEST_URI'] . ' /> ' . REQUEST_URI . '</label><span class="desc">' . ($class['config']->site . '/index.php/hello') . '</span></div>
	</div>
	<div class="row">
		<div class="cell name">' . REWRITE . ': <br /><span class="desc">' . INFO_16 . '</span></div>
		<div class="cell field"><label><input name="rewrite" type="radio" value="1"' . $checked['enable'] . ' /> ' . ENABLE . '</label> &nbsp; <label><input name="rewrite" type="radio" value="0"' . $checked['disable'] . ' /> ' . DISABLE . '</label></div>
	</div>
	<div class="row">
		<div class="cell name">' . ALLOWED_HTML_TAGS . ':<br /><span class="desc">' . INFO_13 . '<br />' . FOR_EXAMPLE . ' &lt;a&gt;&lt;b&gt;&lt;i&gt;&lt;u&gt;</span></div>
		<div class="cell field"><input name="strip_tags" type="text" value="' . $strip_tags . '" /></div>
	</div>
	<div class="row">
		<div class="cell name">' . PERMALINK . ': <br /><span class="desc">' . INFO_15 . '</span></div>
		<div class="cell field"><label><input name="permalink" type="radio" value="INCLUDE"' . $checked['INCLUDE'] . ' /> ' . INCLUDE_SOURCE_IN_PERMALINK_PAGE . '</label><br /><br /><label><input name="permalink" type="radio" value="REDIRECT"' . $checked['REDIRECT'] . ' /> ' . REDIRECT_TO_SOURCE_PAGE . '</label></div>
	</div>
	<div class="row">
		<div class="cell name">' . REGISTRATION . ': <br /><span class="desc">' . INFO_4 . '</span></div>
		<div class="cell field"><label><input name="registration" type="radio" value="1"' . $checked['on'] . ' /> ' . _ON_ . '</label> &nbsp; <label><input name="registration" type="radio" value="0"' . $checked['off'] . ' /> ' . OFF . '</label></div>
	</div>
</div>
<div class="buttons"><input name="update" type="submit" value="' . UPDATE . '" /> &nbsp; <a href="index.php">[' . BACK . ']</a></div>
</form>';

unset($title);
unset($header);
unset($site);
unset($checked);
unset($strip_tags);

$page['title'] = CONFIGURATION;
$page['head'] = '<link href="' . (($class['language']->direction == 'rtl') ? 'rtl/config-rtl.css' : 'config.css') . '" type="text/css" rel="stylesheet" />
<link href="table.css" type="text/css" rel="stylesheet" />
<link href="' . (($class['language']->direction == 'rtl') ? 'rtl/form-rtl.css' : 'form.css') . '" type="text/css" rel="stylesheet" />
<script type="text/javascript" src="config.js"></script>';
$page['content'] = $configuration;

unset($configuration);

?>
