<?php

/*
 * edit.tpl
 *
 * @copyright     Copyright 2009-2011 Hamid Reza Samak
 * @link          http://www.limny.org
 * @package       limny
 * @author        Hamid Reza Samak <hamid@limny.org>
 * @license       GNU/GPL License (http://www.gnu.org/licenses/gpl.html)
 */

require('../incs/file.class.php');
require('../incs/form.class.php');

if(!isset($_GET['p'][1]))
{
	header('Location: index.php');
}

$theme = $_GET['p'][1];

if(!in_array($theme, $class['admin']->themes_list()))
{
	header('Location: index.php');
}

$class['file'] = new File;

$ftp = false;

if(isset($_POST['file_contents']))
{
	$class['form'] = new Form;
	if(isset($_GET['file']) && file_exists('../themes/' . $theme . '/' . $_GET['file']) && $class['form']->validate_referer($class['config']->site . '/admin/index.php?p=edit/', strlen($class['config']->site) + 24))
	{
		if(get_magic_quotes_gpc())
		{
			$_POST['file_contents'] = stripslashes($_POST['file_contents']);
		}
		
		if($class['file']->update_content('../themes/' . $theme . '/' . $_GET['file'], $_POST['file_contents']))
		{
			header('Location: index.php?p=edit/' . $theme);
		}else{
			$ftp = true;
			$error = '&nbsp;';
			if(isset($_POST['host']))
			{
				$connect = (isset($_POST['ssl'])) ? ftp_ssl_connect($_POST['host']) : ftp_connect($_POST['host']); 
				$login = ftp_login($connect, $_POST['user'], $_POST['pass']);
				if($connect && $login)
				{
					$tmpfile = tmpfile();
					fwrite($tmpfile, $_POST['file_contents']);
					fseek($tmpfile, 0);
					$file = $_POST['dir'] . '/themes/' . $theme . '/' . $_GET['file'];
					if(ftp_size($connect, $file) > -1)
					{
						$perm = substr(sprintf('%o', fileperms($file)), -4);
						ftp_chmod($connect, 0777, $file);
						ftp_fput($connect, $file, $tmpfile, FTP_ASCII);
						ftp_chmod($connect, $perm, $file);
						ftp_close($connect);
						header('Location: index.php?p=edit/' . $theme);
					}else{
						$error = '(' . INFO_6 . ')';
					}
				}else{
					$error = '(' . INFO_9 . ')';
				}
			}
		}
	}
	unset($class['form']);
}

$info = $class['admin']->theme_get_info($theme);

$edit = '<div id="files" class="' . $theme . '">
	<label>' . $info['name'] . APOSTROPHE_S . ' ' . FILES . ':</label>
	<br /><div class="files table">';

$files = array();
$exts = array('tpl', 'html', 'css', 'js', 'php', 'htm');
foreach($class['file']->files_list('../themes/' . $theme) as $file)
{
	$ext = explode('.', $file);
	if(in_array(end($ext), $exts))
	{
		array_push($files, $file);
	}
}

unset($class['file']);
unset($exts);

foreach($files as $key => $file)
{
	$edit .= ($key % 3 == 0) ? '<div class="row">' : null;
	
	if(strpos($file, '/'))
	{
		$name = explode('/', $file);
		$name = end($name);
	}else{
		$name = $file;
	}
	
	$edit .= '<div class="cell file"><a href="#' . $file . '">' . $name . '</a></div>';
	
	$edit .= (($key + 1) % 3 == 0) ? '</div>' : null;
}
unset($files);

$edit .= (($key + 1) % 3 != 0) ? '</div>' : null;

$edit .= '</div></div>
<br />';

if($ftp)
{
	$edit .= '<div id="ftp">
<form name="ftp" action="index.php?p=edit/' . $theme . '&file=' . $_GET['file'] . '" method="post">
	<span class="title">FTP</span> <span style="color:#DD0000;">' . $error . '</span>
	<br />
	<p>' . INFO_33 . '</p>
	<div class="table">
		<div class="row">
			<div class="cell name">' . HOST . ':</div>
			<div class="cell"><input name="host" type="text" value="" autocomplete="off" /></div>
		</div>
		<div class="row">
			<div class="cell name">' . USERNAME . ':</div>
			<div class="cell"><input name="user" type="text" value="" autocomplete="off" /></div>
		</div>
		<div class="row">
			<div class="cell name">' . PASSWORD . ':</div>
			<div class="cell"><input name="pass" type="password" value="" /></div>
		</div>
		<div class="row">
			<div class="cell name">&nbsp;</div>
			<div class="cell"><label><input name="ssl" type="checkbox" value="1" /> ' . CONNECT_USING_SSL . '</label></div>
		</div>
		<div class="row">
			<div class="cell name">' . HOME_DIRECTORY . ':</div>
			<div class="cell"><input name="dir" type="text" value="/public_html" autocomplete="off" /></div>
		</div>
	</div>
	<textarea name="file_contents" rows="20" cols="20" style="display:none;">' . str_rep('&,<,>,"', '&amp;,&lt;,&gt;,&quot;', $_POST['file_contents']) . '</textarea>
	<div class="buttons"><input name="update" type="submit" value="' . UPDATE . '" /> &nbsp; <a href="index.php?p=edit/' . $theme . '">[' . BACK . ']</a></div>
</form>
</div>';
}

$edit .= '<div id="edit">
<form name="update_file" action="index.php?p=edit/' . $theme . '" method="post">
<span></span>
<br />
<textarea name="file_contents" rows="20" cols="20"></textarea>
<br />
<div class="buttons"><input name="update" type="submit" value="' . UPDATE . '" /> &nbsp; <a href="index.php?p=appearance">[' . BACK . ']</a></div>
</form>
</div>';

$page['title'] = EDIT . ': ' . $info['name'];
$page['head'] = '<link href="' . (($class['language']->direction == 'rtl') ? 'rtl/edit-rtl.css' : 'edit.css') . '" type="text/css" rel="stylesheet" />
<link href="table.css" type="text/css" rel="stylesheet" />
<link href="' . (($class['language']->direction == 'rtl') ? 'rtl/form-rtl.css' : 'form.css') . '" type="text/css" rel="stylesheet" />
<script type="text/javascript" src="edit.js"></script>';
$page['content'] = $edit;

unset($theme);
unset($info);
unset($edit);

?>
