<?php

/*
 * index.php
 *
 * @copyright     Copyright 2009-2011 Hamid Reza Samak
 * @link          http://www.limny.org
 * @package       limny
 * @author        Hamid Reza Samak <hamid@limny.org>
 * @license       GNU/GPL License (http://www.gnu.org/licenses/gpl.html)
 */

require('init.php');

if(isset($_GET['p']))
{
	$_GET['p'] = explode('/', $_GET['p']);
	if($_GET['p'][0] == 'app' || $class['admin']->is_permitted($_GET['p'][0]))
	{
		include($_GET['p'][0] . '.tpl');
	}else{
		$page = array(
			'title' => PAGE_REQUEST_REFUSED,
			'content' => '<span class="warning">' . PAGE_REQUEST_REFUSED . '</span><br /><br />' . INFO_31
		);
	}
}else{
	include('index.tpl');
}
?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" dir="<?php print $class['language']->direction; ?>">
<head>
<title><?php print (!empty($page['title'])) ? $page['title'] . ' | ' : false; print ADMINISTRATION; ?></title>
<meta http-equiv="Content-Type" content="text/html; charset=<?php print $class['language']->charset; ?>" />
<meta name="generator" content="Limny" />
<link href="<?php print ($class['language']->direction == 'rtl') ? 'rtl/style-rtl.css' : 'style.css'; ?>" type="text/css" rel="stylesheet" />
<link rel="shortcut icon" href="<?php print base_path(); ?>/misc/favicon.ico" type="image/x-icon" />
<script type="text/javascript" src="../misc/jquery.js"></script>
<script type="text/javascript" src="script.js"></script>
<?php print (!empty($page['head'])) ? $page['head'] : false; ?>
</head>
<body>
<div id="header">
	<div id="title"><a href="<?php print $class['config']->site . '/admin'; ?>"><?php print $class['config']->title; ?></a></div>
	<div id="nav">
		<ul class="horizontal">
			<li><label><?php print $_SESSION['_user']; ?></label></li>
			<li>|</li>
			<li>
				<a href="#" class="settings"><?php print SETTINGS; ?> &#9660;</a>
				<ul class="vertical">
					<li style="background-image: url(../misc/widget-16.png);"><a href="index.php?p=widgets"><?php print WIDGETS; ?></a></li>
					<li style="background-image: url(../misc/language-16.png);"><a href="index.php?p=langs"><?php print LANGUAGES; ?></a></li>
					<li style="background-image: url(../misc/application-16.png);"><a href="index.php?p=apps"><?php print APPLICATIONS; ?></a></li>
					<li style="background-image: url(../misc/appearance-16.png);"><a href="index.php?p=appearance"><?php print APPEARANCE; ?></a></li>
					<li style="background-image: url(../misc/configuration-16.png);"><a href="index.php?p=config"><?php print CONFIGURATION; ?></a></li>
					<li style="background-image: url(../misc/role-16.png);"><a href="index.php?p=usersroles"><?php print USERS_AND_ROLES; ?></a></li>
				</ul>
			</li>
			<li>|</li>
			<li><a href="<?php print url('-/logout', true); ?>"><?php print LOGOUT; ?></a></li>
		</ul>
	</div>
</div>
<div id="wrapper">
	<div id="sidebar">
<?php
	$apps_name = $class['config']->apps_name;
	if(!empty($apps_name))
	{
		$apps_name = unserialize($apps_name);		
		$count = count($apps_name);
		
		print '<ul class="apps">';
		foreach($apps_name as $key => $value)
		{
			if($count == 1)
			{
				$cls = 'alone';
			}else{
				if($key == 0)
				{
					$cls = 'first';
				}
				else if($key == ($count -1))
				{
					$cls = 'last';
				}else{
					$cls = 'item';
				}
			}
			
			$icon = (file_exists('../apps/' . $value[0] . '/icon.png')) ? ' ../apps/' . $value[0] . '/icon.png' : '../misc/application-32.png';
			
			print '<li id="app_' . $value[0] . '" class="app ' . $cls . '" style="background-image: url(' . $icon . ');"><a href="index.php?p=app/' . $value[0] . '">' . $value[1] . '</a><div class="features"></div></li>';
		}
		print '</ul>';
	}else{
		print '<div class="getanapp"><a href="http://www.limny.org/get-app">' . GET_AN_APP . '</a></div>';
	}
?>
	</div>
	<div id="content"><?php print (!empty($page['content'])) ? $page['content'] : false; ?></div>
</div>
<div style="clear:both;"></div>
<div id="footer"><a href="http://www.limny.org" title="Powered by Limny"><img alt="Powered by Limny" src="../misc/limny-button.png" /></a></div>
</body>
</html>
