<?php

/*
 * styles.tpl
 *
 * @copyright     Copyright 2009-2011 Hamid Reza Samak
 * @link          http://www.limny.org
 * @package       limny
 * @author        Hamid Reza Samak <hamid@limny.org>
 * @license       GNU/GPL License (http://www.gnu.org/licenses/gpl.html)
 */

require('../incs/file.class.php');
require('../incs/form.class.php');

if(!isset($_GET['p'][1]))
{
	header('Location: index.php');
}

$theme = $_GET['p'][1];

if(!in_array($theme, $class['admin']->themes_list()))
{
	header('Location: index.php');
}

$class['form'] = new Form;

if(isset($_POST['update']) && $class['form']->validate_referer($class['config']->site . '/admin/index.php?p=styles/', strlen($class['config']->site) + 26))
{
	$error = false;
	
	$query = $db->select('id, type', 'styles', 'WHERE theme=\'' . add_slashes($theme) . '\'');
	while($style = $db->fetch_array($query))
	{
		if(isset($_POST['styles_' . $style['id']]))
		{
			$value = $_POST['styles_' . $style['id']];
			
			if($style['type'] == 'CLR')
			{
				$error = (!preg_match('/^(#)?([0-9a-fA-F]{3})([0-9a-fA-F]{3})?$/', $value)) ? true : false;
			}
			else if($style['type'] == 'NUM')
			{
				$error = (!is_numeric($value)) ? true : false;
			}
			else if($style['type'] == 'TXT')
			{
				$value = str_rep('<,>,",&', '&lt;,&gt;,&quot;,&amp;', $value);
			}
			
			if(!$error)
			{
				$db->update('styles', 'value=\'' . add_slashes($value) . '\' WHERE id=\'' . $style['id'] . '\'');
			}
		}
	}
	

	$query = $db->select('id, pattern, `values`', 'images', 'WHERE theme=\'' . add_slashes($theme) . '\' AND pattern!=0');
	while($image = $db->fetch_array($query))
	{
		$values = unserialize($image['values']);
		$new_values = array();
		
		$pattern_query = $db->select('function, variables', 'patterns', 'WHERE id=\'' . $image['pattern'] . '\'');
		$type = ($pattern = $db->fetch_array($pattern_query)) ? array_values(unserialize($pattern['variables'])) : null;
		
		for($i = 0; $i < 999; $i++)
		{
			if(isset($_POST[$image['id'] . '_' . $i]))
			{
				$value = $_POST[$image['id'] . '_' . $i];
				
				if($type[$i] == 'CLR')
				{
					$error = (!preg_match('/^(#)?([0-9a-fA-F]{3})([0-9a-fA-F]{3})?$/', $value)) ? true : false;
				}
				else if($type[$i] == 'NUM')
				{
					$error = (!is_numeric($value)) ? true : false;
				}
				else if($type[$i] == 'TXT')
				{
					$value = str_rep('<,>,",&', '&lt;,&gt;,&quot;,&amp;', $value);
				}
				
				if(!$error)
				{
					array_push($new_values, $value);
				}else{
					array_push($new_values, $values[$i]);
				}
			}else{
				$code = base64_encode(eval_this('<?php ' . str_replace('function __pattern', 'function __pattern_' . md5($image['id']), $pattern['function']) . ' ob_start(); __pattern_' . md5($image['id']) . '(array(\'' . implode('\', \'', $new_values) . '\')); $code = ob_get_contents(); ob_end_clean(); return $code; ?>'));
				$db->update('images', '`values`=\'' . add_slashes(serialize($new_values)) . '\', image=\'' . add_slashes($code) . '\' WHERE id=\'' . $image['id'] . '\'');
				break;
			}
		}
	}
	
	$class['file'] = new File;
	
	$query = $db->select('id', 'images', 'WHERE theme=\'' . add_slashes($theme) . '\' AND pattern=0');
	while($image = $db->fetch_array($query))
	{
		if(isset($_FILES[$image['id'] . '_file']))
		{
			$file = $_FILES[$image['id'] . '_file'];
			if(!empty($file['name']) && $file['size'] > 0)
			{
				$db->update('images', 'image=\'' . add_slashes(base64_encode($class['file']->get_contents($file['tmp_name']))) . '\' WHERE id=\'' . $image['id'] . '\'');
			}
		}
	}
	
	unset($class['file']);
}

$info = $class['admin']->theme_get_info($theme);

$query = $db->select('id, name, type, value', 'styles', 'WHERE theme=\'' . add_slashes($theme) . '\'');
if($db->num_rows($query) > 0)
{
	$num = $db->num_rows($query);
	$phrase = ($num == 1) ? OPTION : OPTIONS;
	$styles = '<span class="title">' . STYLES . '</span> <span class="desc">(' . $num . ' ' . $phrase . ')</span>
<div class="table tbl">';
	unset($num);
	while($style = $db->fetch_array($query))
	{
		$color = ($style['type'] == 'CLR') ? ' class="color"' : null;
		$styles .= '<div class="row"><div class="cell name">' . $style['name'] . ':</div><div class="cell value"><input name="styles_' . $style['id']. '" type="text" value="' . $style['value'] . '"' . $color . ' autocomplete="off" /></div></div>';
	}
	$styles .= '</div>';
}else{
	$styles = '';
}

$images = '';
$query = $db->select('id, name, pattern, `values`', 'images', 'WHERE theme=\'' . add_slashes($theme) . '\' ORDER BY id ASC');
while($image = $db->fetch_array($query))
{
	if($image['pattern'] == '0')
	{
		$name = FILE;
	}else{
		$pattern_query = $db->select('name, variables', 'patterns', 'WHERE id=\'' . $image['pattern'] . '\'');
		if($pattern = $db->fetch_array($pattern_query))
		{
			$name = $pattern['name'];
			$variables = unserialize($pattern['variables']);
			unset($pattern);
		}
	}
	
	$images .= '<span class="title">' . $image['name'] . '</span> <span class="desc">(' . $name . ')</span>
<div class="table tbl">';
	
	if(isset($variables))
	{
		$values = unserialize($image['values']);
		$i = 0;
		foreach($variables as $key => $value)
		{
			$color = ($value == 'CLR') ? ' class="color"' : null;
			
			$images .= '<div class="row"><div class="cell name">' . $key . ':</div><div class="cell value"><input name="' . $image['id'] . '_' . $i . '" type="text" value="' . $values[$i] . '"' . $color . ' autocomplete="off" /></div></div>';
			$i++;
		}
		unset($variables);
	}else{
		$images .= '<div class="row"><div class="cell name">' . UPLOAD . ':</div><div class="cell value"><input name="' . $image['id'] . '_file" type="file" value="" /></div></div>';
	}
	
	$images .= '</div>';
}

if(!empty($images))
{
	if(!extension_loaded('gd') || !function_exists('gd_info'))
	{
		$message = '<div class="message">' . INFO_34 . '</div>';
	}
}

$page['title'] = STYLES . ': ' . $info['name'];

unset($info);

$page['head'] = '<link href="styles.css" type="text/css" rel="stylesheet" />
<link href="table.css" type="text/css" rel="stylesheet" />
<link href="' . (($class['language']->direction == 'rtl') ? 'rtl/form-rtl.css' : 'form.css') . '" type="text/css" rel="stylesheet" />
<link href="farbtastic.css" type="text/css" rel="stylesheet" />
<script type="text/javascript" src="farbtastic.js"></script>
<script type="text/javascript" src="styles.js"></script>';
$page['content'] = ((isset($message)) ? $message : null) . '<div id="picker"></div><form name="update" action="index.php?p=styles/' . $theme . '" method="post" enctype="multipart/form-data">' . $styles . $images . '<div class="buttons"><input name="update" type="submit" value="' . UPDATE . '"' . ((isset($message)) ? ' disabled="disabled"' : null) . ' /> &nbsp; <a href="index.php?p=appearance">[' . BACK . ']</a></div></form>';

unset($styles);
unset($images);
unset($theme);

?>
