<?php

/*
 * widgets.tpl
 *
 * @copyright     Copyright 2009-2011 Hamid Reza Samak
 * @link          http://www.limny.org
 * @package       limny
 * @author        Hamid Reza Samak <hamid@limny.org>
 * @license       GNU/GPL License (http://www.gnu.org/licenses/gpl.html)
 */

require('../incs/file.class.php');
$class['file'] = new File;

$theme = $class['config']->theme;
$info = $class['file']->get_contents('../themes/' . $theme . '/' . $theme . '.info');
unset($class['file']);
unset($theme);

$data = explode("\r\n\r\n", $info);
unset($info);
$blocks = $data[2];
unset($data);
$blocks = explode("\r\n", $blocks);

$names = array();
foreach($blocks as $line)
{
	$block = explode('|', $line);
	foreach($block as $key => $widget)
	{
		$widget = ($key == 0) ? substr($widget, 2, strlen($widget)) : $widget;
		array_push($names, strtolower(trim(substr($widget, 0, strpos($widget, '(')))));
	}
}

$widgets = '';
$query = $db->select('id, name, position', 'widgets', 'ORDER BY id ASC');
while($widget = $db->fetch_array($query))
{
	if($widget['position'] == 'none' || !in_array($widget['position'], $names))
	{
		$widgets .= '<div id="limny_widget_' . $widget['position'] . '_' . $widget['id'] . '" class="widget">
	<span class="name">' . $widget['name'] . '</span>
	<span class="status"><noscript><a href="index.php?p=widget/' . $widget['position'] . '/' . $widget['id'] . '/0"><img border="0" width="24" height="24" src="../misc/transparent.gif" alt="transparent" /></a></noscript></span>
	<div style="clear:both;"></div>
</div>';
	}
}

$page['content'] = '<div id="limny_block_none" class="widgets">
	<label>' . AVAILABLE_WIDGETS . ':</label>
	<br />
	' . $widgets . '
	<div style="clear:both;"></div>
</div>
<div style="width:100%;">';
unset($widgets);

foreach($blocks as $line)
{
	$page['content'] .= '<div>';
	$block = explode('|', $line);
	foreach($block as $key => $value)
	{
		$value = ($key == 0) ? substr($value, 2, strlen($value)) : $value;
		$name = strtolower(trim(substr($value, 0, strpos($value, '('))));
		$start_css = strpos($value, '(');
		$css = substr($value, $start_css + 1, strrpos($value, ')') - $start_css - 1);
		
		$widgets = '';
		$query = $db->select('id, name', 'widgets', 'WHERE position=\'' . add_slashes($name) . '\' ORDER BY id ASC');
		while($widget = $db->fetch_array($query))
		{
			$widgets .= '<div id="limny_widget_' . $name . '_' . $widget['id'] . '" class="widget">
	<span class="name">' . $widget['name'] . '</span>
	<span class="status"><noscript><a href="index.php?p=widget/' . $name . '/' . $widget['id'] . '/1"><img border="0" width="24" height="24" src="../misc/transparent.gif" alt="transparent" /></a></noscript></span>
	<div style="clear:both;"></div>
</div>';
		}
		
		$page['content'] .= '<div id="limny_block_' . $name . '" class="block" style="' . $css . '">' . $widgets . '</div>';
	}
	unset($start_css);
	unset($widgets);
	unset($block);
	unset($name);
	unset($css);
	
	$page['content'] .= '<div style="clear:both;"></div></div>';
}

$page['content'] .= '</div>';

$page['title'] = WIDGETS;
$page['head'] = '<link href="' . (($class['language']->direction == 'rtl') ? 'rtl/widgets-rtl.css' : 'widgets.css') . '" type="text/css" rel="stylesheet" />
<script type="text/javascript" src="../misc/jquery-ui.js"></script>
<script type="text/javascript" src="widgets.js"></script>';

?>
