<?php

/*
 * content.class.php
 *
 * @copyright     Copyright 2009-2011 Hamid Reza Samak
 * @link          http://www.limny.org
 * @package       limny
 * @author        Hamid Reza Samak <hamid@limny.org>
 * @license       GNU/GPL License (http://www.gnu.org/licenses/gpl.html)
 */

class Content
{
	function make()
	{
		$q = query();
		
		if(!empty($q[0]))
		{
			if($q[0] == '-' && !empty($q[1]))
			{
				if($this->is_systemic($q[1]))
				{
					$page = $this->sys_to_content($q[1]);
				}
			}else{
				$class['application'] = new Application;	
				if($class['application']->is_installed($q[0]) && $class['application']->is_enabled($q[0]))
				{
					$page = $this->app_to_content($q[0]);
				}else{
					$class['permalink'] = new Permalink;
					
					$q = implode('/', $q);
					if($class['permalink']->is_permalink($q))
					{
						$class['config'] = new Config;
						if($class['config']->permalink == 'INCLUDE')
						{
							$query = $class['permalink']->get_query($q);
							$q = explode('/', $query);
							if($class['application']->is_installed($q[0]) && $class['application']->is_enabled($q[0]))
							{
								$page = $this->app_to_content($q[0]);
							}
						}else{
							header('Location: ' . url($class['permalink']->get_query($q)));
							return false;
						}
					}
				}
			}
		}else{
			$page = $this->default_content();
		}
		
		if(!isset($page))
		{
			$page = $this->page_not_found();
		}
		return $page;
	}
	
	function sys_to_content($sys)
	{
		global $db;
		
		$query = $db->select('eval', 'system', 'WHERE name=\'' . add_slashes($sys) . '\'');
		return ($system = $db->fetch_array($query)) ? eval_this($system['eval']) : false;
	}
	
	function is_systemic($name)
	{
		global $db;
		
		$query = $db->select('name', 'system', 'WHERE name=\'' . add_slashes($name) . '\'');
		return ($system = $db->fetch_array($query)) ? true : false;
	}
	
	function app_to_content($app)
	{
		global $db;
		
		$query = $db->select('eval', 'apps', 'WHERE name=\'' . add_slashes($app) . '\'');
		return ($content = $db->fetch_array($query)) ? eval_this($content['eval']) : false;
	}
	
	function default_content()
	{
		$class['config'] = new Config;
		
		switch($class['config']->content_default)
		{
			case('app');
				$app = $class['config']->content_app;
				$class['application'] = new Application;
				if($class['application']->is_installed($app) && $class['application']->is_enabled($app))
				{
					$page = $this->app_to_content($app);
				}else{
					return $this->page_not_found();
				}
			break;
			
			case('query');
				$class['application'] = new Application;
				
				$q = explode('/', $class['config']->content_query);
				if($class['application']->is_installed($q[0]) && $class['application']->is_enabled($q[0]))
				{
					if($class['config']->uri_mode == 'REQUEST_URI')
					{
						$_SERVER['REQUEST_URI'] = 'index.php/' . implode('/', $q);
					}else{
						$_GET['q'] = implode('/', $q);
					}
					$page = $this->app_to_content($q[0]);
				}else{
					return $this->page_not_found();
				}
			break;
			
			case('code');
				$code = eval_this($class['config']->content_code);
				if(is_array($code))
				{
					return $code;
				}
				else if(is_string($code))
				{
					return array('content' => $code);
				}
			break;
		}
		
		return $page;
	}
	
	function page_not_found()
	{
		return array('title' => PAGE_NOT_FOUND, 'content' => PAGE_NOT_FOUND_MESSAGE);
	}
}

?>
