<?php

/*
 * file.class.php
 *
 * @copyright     Copyright 2009-2011 Hamid Reza Samak
 * @link          http://www.limny.org
 * @package       limny
 * @author        Hamid Reza Samak <hamid@limny.org>
 * @license       GNU/GPL License (http://www.gnu.org/licenses/gpl.html)
 */

class File
{
	function update_content($file, $content)
	{
		$file = @fopen($file, 'w+');
		$result = (fwrite($file, $content)) ? true : false;
		fclose($file);
		return $result;
	}
	
	function files_list($path)
	{
		$files = array();
		$dir = opendir($path);
		while($file = readdir($dir))
		{
			if($file != '.' && $file != '..')
			{
				if(is_dir($path . '/' . $file))
				{
					foreach($this->files_list($path . '/' . $file) as $value)
					{
						array_push($files, $file . '/' . $value);
					}
				}else{
					array_push($files, $file);
				}
			}
		}
		closedir($dir);
		return $files;
	}
	
	function get_contents($file, $size = '')
	{
		if(empty($size))
		{
			$size = @filesize($file);
			if(!$size)
			{
				$size = 10000000;
			}
		}
		
		$file = fopen($file, 'r');
		$content = fread($file, $size);
		$file = fclose($file);
		return $content;
	}
	
	function get_version($file)
	{
		if(file_exists($file))
		{
			$contents = $this->get_contents($file);
			$lines = explode("\n", $contents);
			$info = explode(',', $lines[0]);
			return trim($info[1]);
		}
		return false;
	}
	
	function load_style($app, $file = 'style.css')
	{
		$class['language'] = new Language;
		if($class['language']->direction == 'rtl')
		{
			$file = str_replace('.', '-rtl.', $file);
		}
		
		$class['user'] = new User;
		$class['config'] = new Config;
		$theme = $class['config']->theme;
		if($class['user']->is_authorized())
		{
			$user_theme = $class['user']->user_get_info('theme');
			if(!empty($user_theme))
			{
				$theme = $user_theme;
			}
		}
		
		$theme_style = 'themes/' . $theme . '/' . $app . '-' . end(explode('/', $file));
		if(file_exists($theme_style))
		{
			$style = $theme_style;
		}else{
			$style = 'apps/' . $app . '/' . $file;
		}
		
		return '<link rel="stylesheet" href="' . base_path() . '/' . $style . '" type="text/css" />';
	}
	
	function load_template($app, $file)
	{
		$class['user'] = new User;
		$class['config'] = new Config;
		$theme = $class['config']->theme;
		if($class['user']->is_authorized())
		{
			$user_theme = $class['user']->user_get_info('theme');
			if(!empty($user_theme))
			{
				$theme = $user_theme;
			}
		}
		
		$theme_temp = 'themes/' . $theme . '/' . $app . '-' . end(explode('/', $file));
		if(file_exists($theme_temp))
		{
			$content = $this->get_contents($theme_temp);
		}else{
			$content = $this->get_contents($file);
		}
		
		$temp = '';
		$content = explode('{', $content);
		foreach($content as $value)
		{
			$value = explode('}', $value);
			if(count($value) == 1)
			{
				$temp .= str_rep('\',&#123;,&#125;', '\\\',{,}', $value[0]);
			}else{
				$temp .= '\' . ' . $value[0] . ' . \'' . str_rep('\',&#123;,&#125;', '\\\',{,}', $value[1]);
			}
		}
		return 'return \'' . $temp . '\';';
	}
	
}

?>
