<?php

/*
 * language.class.php
 *
 * @copyright     Copyright 2009-2011 Hamid Reza Samak
 * @link          http://www.limny.org
 * @package       limny
 * @author        Hamid Reza Samak <hamid@limny.org>
 * @license       GNU/GPL License (http://www.gnu.org/licenses/gpl.html)
 */

class Language
{
	public $language;
	public $direction;
	public $charset;
	
	function __construct()
	{
		$q = query(true);
		if(count($q) > 0)
		{
			if(in_array($q[0], $this->languages('value')))
			{
				$this->language = $q[0];
				$this->charset = $this->language($q[0], 'charset');
				$this->direction = $this->language($q[0], 'direction');
				return false;
			}
		}
		
		$class['user'] = new User;
		$class['config'] = new Config;
		
		if($class['user']->is_authorized() && $class['user']->user_get_info('language') != '')
		{
			$this->language = $class['user']->user_get_info('language');
		}else{
			
			$this->language = $class['config']->language;
		}
		
		$this->charset = $this->language($this->language, 'charset');
		$this->direction = $this->language($this->language, 'direction');
	}
	
	function languages($field = '', $arguments = '')
	{
		global $db;
		
		$languages = array();
		if(empty($field))
		{
			$query = $db->select('*', 'languages', $arguments);
			while($language = $db->fetch_array($query))
			{
				array_push($languages, $language);
			}
		}else{
			$field = add_slashes($field);
			$query = $db->select($field, 'languages', $arguments);
			while($language = $db->fetch_array($query))
			{
				array_push($languages, $language[$field]);
			}
		}
		return $languages;
	}
	
	function language($value, $field)
	{
		global $db;
		
		$query = $db->select($field, 'languages', 'WHERE value=\'' . add_slashes($value) . '\'');
		return ($language = $db->fetch_array($query)) ? $language[$field] : false;
	}
}

?>
